//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"


#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  clrDodgerBlue
#property indicator_color2  clrRed
#property indicator_color3  clrDodgerBlue
#property indicator_color4  clrRed
#property indicator_color5  clrDodgerBlue
#property indicator_color6  clrRed

//
//
//
//
//
//

enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1,     // Monthly
   tf_cus = 12345678        // Custom time frame
};

extern enTimeFrames   TimeFrame       = tf_cu;    // Time frame
extern int            TimeFrameCustom = 0;        // Custom time frame to use (if custom time frame used)
extern int            ChannelPeriod   = 9;
extern double         Risk            = 0.30;
extern bool           alertsOn        = true;
extern bool           alertsOnCurrent = true;
extern bool           alertsMessage   = true;
extern bool           alertsSound     = false;
extern bool           alertsNotify    = false;
extern bool           alertsEmail     = false;
extern bool           Interpolate     = true; 

//
//
//
//
//
//

double UpSign[];
double DnSign[];
double UpStop[];
double DnStop[];
double UpLine[];
double DnLine[];
double bsmax[];
double bsmin[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                        
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,UpSign); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108); 
   SetIndexBuffer(1,DnSign); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108); 
   SetIndexBuffer(2,UpStop); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159); 
   SetIndexBuffer(3,DnStop); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159); 
   SetIndexBuffer(4,UpLine);                                                
   SetIndexBuffer(5,DnLine);                                                  
   SetIndexBuffer(6,bsmax);
   SetIndexBuffer(7,bsmin); 
   SetIndexBuffer(8,trend); 
   
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99; 
         if (TimeFrameCustom==0) TimeFrameCustom = MathMax(TimeFrameCustom,_Period);
         if (TimeFrame!=tf_cus)
               TimeFrame = MathMax(TimeFrame,_Period);
         else  TimeFrame = (enTimeFrames)TimeFrameCustom;
            
   
   IndicatorShortName(timeFrameToString(TimeFrame)+" PriceChannel_Stop_v1("+ChannelPeriod+")");
return(0);
}                                                  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpSign[0] = limit+1; return(0); }
         

   //
   //
   //
   //
   //
   
   if (TimeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {
        double hi = High[i]; for(k=1; k<ChannelPeriod && (i+k)>=0; k++) hi = MathMax(hi,High[i+k]);
        double lo = Low[i];  for(k=1; k<ChannelPeriod && (i+k)>=0; k++) lo = MathMin(lo, Low[i+k]);
     
        bsmax[i]=hi-(hi-lo)*Risk;
	     bsmin[i]=lo+(hi-lo)*Risk;
	   
        UpSign[i] = EMPTY_VALUE;
        DnSign[i] = EMPTY_VALUE;
        UpStop[i] = EMPTY_VALUE;
        DnStop[i] = EMPTY_VALUE;
        UpLine[i] = EMPTY_VALUE;
        DnLine[i] = EMPTY_VALUE;
        if (i<(Bars-1))
        {
          trend[i]  = trend[i+1]; 
          if (Close[i]>bsmax[i+1])  trend[i] = 1; 
	       if (Close[i]<bsmin[i+1])  trend[i] =-1;  		
	       if(trend[i]>0 && bsmin[i]<bsmin[i+1]) bsmin[i]=bsmin[i+1];
	       if(trend[i]<0 && bsmax[i]>bsmax[i+1]) bsmax[i]=bsmax[i+1];
	       if (trend[i] == 1) { UpLine[i]=bsmin[i]; UpStop[i]=bsmin[i];  if (trend[i+1]!= 1) UpSign[i] = UpLine[i]; }
	       if (trend[i] ==-1) { DnLine[i]=bsmax[i]; DnStop[i]=bsmax[i];  if (trend[i+1]!=-1) DnSign[i] = DnLine[i]; }
	     }
	 
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("up");
     else  doAlert("down");       
   }   
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         UpLine[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,ChannelPeriod,Risk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,4,y);
         DnLine[i]  = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,ChannelPeriod,Risk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,5,y);
         UpSign[i] = EMPTY_VALUE;
         DnSign[i] = EMPTY_VALUE;
         UpStop[i] = EMPTY_VALUE;
         DnStop[i] = EMPTY_VALUE;
            if (UpLine[i]!= EMPTY_VALUE)                             UpStop[i]=UpLine[i];
            if (DnLine[i]!= EMPTY_VALUE)                             DnStop[i]=DnLine[i];
            if (UpLine[i]!= EMPTY_VALUE && UpLine[i+1]==EMPTY_VALUE) UpSign[i]=UpLine[i];
            if (DnLine[i]!= EMPTY_VALUE && DnLine[i+1]==EMPTY_VALUE) DnSign[i]=DnLine[i];
            
            //
            //
            //
            //
            //
                        
            if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

            //
            //
            //
            //
            //

            int n,x; datetime time = iTime(NULL,TimeFrame,y);
               for(n = 1; i+n<Bars && Time[i+n] >= time; n++) continue;	
               for(x = 1; i+n<Bars && i+x<Bars && x<n; x++)
               {
                  if (UpLine[i]!=EMPTY_VALUE && UpLine[i+n]!=EMPTY_VALUE) UpLine[i+x] = UpLine[i] + (UpLine[i+n]-UpLine[i])*x/n;
                  if (DnLine[i]!=EMPTY_VALUE && DnLine[i+n]!=EMPTY_VALUE) DnLine[i+x] = DnLine[i] + (DnLine[i+n]-DnLine[i])*x/n;
                  if (UpStop[i+x] != EMPTY_VALUE) UpStop[i+x] = UpLine[i+x];
                  if (DnStop[i+x] != EMPTY_VALUE) DnStop[i+x] = DnLine[i+x];
               }
   }
return(0);         
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Price Channel Stop ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Price Channel Stop "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


